/**<pre>
 * Title: iSIM
 * Copyright: Copyright (c) 2002
 * Company:   University of Oregon Computer Science Dept.
 *
 * @author Jason Prideaux
 * @version 1.0
 * </pre>
 */

package state;


import state.events.*;
import gui.tray.*;
import util.*;
import agent.*;
import controller.*;
import transport.*;
import transport.protocol.*;

import javax.swing.JFrame;
import java.awt.*;
import java.util.*;



/* ====================================================================== */
/** This class loops through the list of events, and performs the events
 *  behalf of the agents.
 *
 */
public class StateMachine {


	/**  */
	private Vector events;

	/**  */
	private Controller controller;


	private int state;



    /* ===================================================================== */
    /** This constructor initializes
     *
     */
	public StateMachine( Controller controller, Vector events ){

		this.events = events;
		this.controller = controller;

		state = 0;

	} //Constructor




    /* ===================================================================== */
    /** This method is
     *
     *  @return  Vector   A set of at least two reference points.
     *
     */
    public void incrementState(){

		Message msg = (Message)(events.elementAt(state));

		SocketSender ss = new SocketSender(msg);
		ss.start();

		state++;

	}


    /* ===================================================================== */
    /** This method is
     *
     *  @return  Vector   A set of at least two reference points.
     *
     */
    public void decrementState(){

		if( state > 0 ){
			state--;
		}
	}



    /* ===================================================================== */
    /** This method is
     *
     *  @return  Vector   A set of at least two reference points.
     *
     */
    public Vector getEvents(){
		return events;
	}


    /* ===================================================================== */
    /** This method is
     *
     *  @return  Vector   A set of at least two reference points.
     *
     */
    public int getCurrentStateIndex(){
		return state;
	}




} //class: StateMachine