package threed;

import util.*;
import gui.*;
import map.*;
import java.applet.Applet;
import java.awt.*;
import java.io.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.picking.PickTool;
import com.sun.j3d.utils.picking.behaviors.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.loaders.objectfile.ObjectFile;
import com.sun.j3d.loaders.Loader;
import com.sun.j3d.loaders.Scene;



import javax.media.j3d.*;
import javax.vecmath.*;
import javax.swing.*;
import java.util.*;

public class SceneGeneratorA  extends Applet {

	private Building building;
	private String fileName;
	private static double NOVAL = -99999.99999;
	private double minLong = NOVAL;
	private double minLat = NOVAL;
	private double maxLong = NOVAL;
	private double maxLat = NOVAL;
	private double scalingFactor;
    private SimpleUniverse u = null;
    private GraphicsConfiguration config;
    private Canvas3D c;
    private BranchGroup scene;
    private JPanel panel;
    private JButton in;
    private JButton out;
    private JButton left;
    private JButton right;
    private JButton god;
    private double xPos = 0.0d;
    private double yPos = 0.30d;
    private double zPos = 0.0d;
    private double heading = 180.0d; // heading
    private Texture tex;
	private TransformGroup objScale;
	private double floorHeight = 0.0d;
	private double ceilingHeight = 0.3d;
	private int maxFloorHeight = 0;
	private boolean isLoaded = false;

	public SceneGeneratorA(String fname){
		fileName = fname;
	}

	public SceneGeneratorA(Building bld){
		building = bld;
	}

	public boolean isLoaded(){
		return isLoaded;
	}

	public void loadBuilding(String fname){
		try{
			FileInputStream fin = new FileInputStream(fname);
			ObjectInputStream oin = new ObjectInputStream(fin);
			building = (Building)oin.readObject();
			System.out.println("building object loaded");
		} catch(Exception e){
			System.out.println("Error Loading Map File:" + e);
			building = new Building("Empty");
		}
	}

	public static void main(String[] args) {
	    new MainFrame(new SceneGeneratorA("house.map"), 700, 700);
  	}

	public void printInfo(){
		findScale();
		System.out.println("Map Size:");
		System.out.println("("+minLong+","+minLat+") --> ("+maxLong+","+maxLat+")");
		Vector floors = building.getFloors();
		for(int f=0;f<floors.size();f++){
			System.out.println("Floor #" + (f+1));
			Vector rooms = ((Floor)floors.get(f)).getRooms();
			for(int r=0;r<rooms.size();r++){
				System.out.println(" - Room #" + (r+1));
				Vector walls = ((Room)rooms.get(r)).getWalls();
				for(int w=0;w<walls.size();w++){
					System.out.println("   + Wall #" + (w+1));
					System.out.println("     (" + convertLong(((Wall)walls.get(w)).getPosition1().getPureLng())+","+convertLat(((Wall)walls.get(w)).getPosition1().getPureLat()) + ") --> (" + convertLong(((Wall)walls.get(w)).getPosition2().getPureLng())+","+convertLat(((Wall)walls.get(w)).getPosition2().getPureLat())+")");
				}
			}
		}
	}

	public BranchGroup createSceneGraph(Canvas3D canvas) {
		Color3f eColor    = new Color3f(0.0f, 0.0f, 0.0f);
	    Color3f sColor    = new Color3f(1.0f, 1.0f, 1.0f);
	    Color3f objColor  = new Color3f(0.6f, 0.6f, 0.6f);
	    Color3f lColor1   = new Color3f(0.8f, 0.0f, 0.0f);
	    Color3f lColor2   = new Color3f(0.8f, 0.8f, 0.8f);
	    Color3f alColor   = new Color3f(0.2f, 0.2f, 0.2f);
	    Color3f bgColor   = new Color3f(0.05f, 0.05f, 0.2f);

	    Transform3D t;

	    // Create the root of the branch graph
	    BranchGroup objRoot = new BranchGroup();

	    // Create a Transformgroup to scale all objects so they
	    // appear in the scene.
	    objScale = new TransformGroup();
	    Transform3D t3d = new Transform3D();
	    t3d.setScale(1.0);
	    objScale.setTransform(t3d);
	    objRoot.addChild(objScale);

	    // Create a bounds for the background and lights
	    BoundingSphere bounds =
	      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

	    // Set up the background
	    Background bg = new Background(bgColor);
	    bg.setApplicationBounds(bounds);
	    objScale.addChild(bg);


	    t = new Transform3D();
	    Vector3d lPos1 =  new Vector3d(1.0, 1.0, 1.0);
	    t.set(lPos1);
	    TransformGroup l1Trans = new TransformGroup(t);
	    l1Trans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	    l1Trans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	    l1Trans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
    	objScale.addChild(l1Trans);

    	ColoringAttributes caL1 = new ColoringAttributes();
		caL1.setColor(lColor1);
		Appearance appL1 = new Appearance();
		appL1.setColoringAttributes(caL1);
		l1Trans.addChild(new Sphere(0.05f,Sphere.GENERATE_NORMALS | Sphere.ENABLE_GEOMETRY_PICKING, 15, appL1));

		Light lgt1;
		Point3f lPoint  = new Point3f(0.0f, 4.0f, 0.0f);
		Point3f atten = new Point3f(0.0f, -1.0f, 0.0f);
		lgt1 = new PointLight(lColor1, lPoint, atten);

		// Set the influencing bounds
		lgt1.setInfluencingBounds(bounds);

		// Add the lights into the scene graph
		l1Trans.addChild(lgt1);



	    Material m = new Material(objColor, eColor, objColor, sColor, 100.0f);
	    Appearance a = new Appearance();
	    m.setLightingEnable(true);
	    a.setMaterial(m);

	    AmbientLight aLgt = new AmbientLight(alColor);
    	aLgt.setInfluencingBounds(bounds);
	    objScale.addChild(aLgt);

	    // Let Java 3D perform optimizations on this scene graph.

		//MY CODE STARTS HERE
		System.out.println("Finding Scaling Factor");
		if(building == null)
			loadBuilding(fileName);
		findScale();
		//printInfo();

		// add floor\
		Texture texF = new Texture2D();
		Texture texG = new Texture2D();
		try {
			System.out.println("loading texture file");
		    texF = new TextureLoader("files/textures/carpet2.gif", this).getTexture();
		    texG = new TextureLoader("files/textures/grass.jpg", this).getTexture();
		    texG.setMinFilter(Texture.NICEST);
		    texF.setMinFilter(Texture.NICEST);
		    System.out.println("texture file loaded");
		}
		catch (Exception e) {
		    System.err.println(e);
		    System.exit(1);
        }

		t = new Transform3D();
		Transform3D t2 = new Transform3D();
		// Calculate the Vector required to correctly position the center of the wall
		Vector3d floorPos =  new Vector3d(0.0d, 0.0d, 0.0);
		Vector3d grassPos = new Vector3d(0.0d,-0.01d,0.0d);
		t.set(floorPos);
		t2.set(grassPos);

		TransformGroup floorTrans = new TransformGroup(t);
		TransformGroup grassTrans = new TransformGroup(t2);
		floorTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		floorTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		floorTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
		objScale.addChild(floorTrans);
		objScale.addChild(grassTrans);

		ColoringAttributes caFloor = new ColoringAttributes();
		caFloor.setColor(lColor2);
		Appearance appFloor = new Appearance();
		Appearance appGrass = new Appearance();
		appFloor.setTexture(texF);
		appGrass.setTexture(texG);
		appFloor.setColoringAttributes(caFloor);
		TextureAttributes texAttrF = new TextureAttributes();
		TextureAttributes texAttrG = new TextureAttributes();
		texAttrF.setTextureMode(TextureAttributes.MODULATE);
		texAttrG.setTextureMode(TextureAttributes.MODULATE);
		appFloor.setTextureAttributes(texAttrF);
		appGrass.setTextureAttributes(texAttrG);
		floorTrans.addChild(new com.sun.j3d.utils.geometry.Box(2.0f,0.01f,2.0f,com.sun.j3d.utils.geometry.Box.GENERATE_TEXTURE_COORDS,appFloor));
		grassTrans.addChild(new com.sun.j3d.utils.geometry.Box(100.0f,0.009f,100.0f,com.sun.j3d.utils.geometry.Box.GENERATE_TEXTURE_COORDS,appGrass));


		// Add the robot
		t = new Transform3D();
		TransformGroup robotTrans = new TransformGroup();
		floorPos =  new Vector3d(0.0d, 0.15d, 1.0);
		t.set(floorPos);
		t.setScale(0.10);


		robotTrans.setTransform(t);
	    objScale.addChild(robotTrans);

		int flags = ObjectFile.RESIZE;
		ObjectFile of = new ObjectFile(flags, (float)(60.0 * Math.PI / 180.0));
		Scene s = null;
		try {
		  s = of.load("files/models/er1.obj");
		}
		catch (Exception e) {
		  System.err.println(e);
		  System.exit(1);
		}

		robotTrans.addChild(s.getSceneGroup());

		tex = new Texture2D();
		try{
			tex = new TextureLoader("files/textures/whitewall.jpg", this).getTexture();
		}catch(Exception e){System.out.println("error loading texture: "+e);}

		System.out.println("Scaling Factor: " + scalingFactor);
		System.out.print("Creating Walls");
		Vector floors = building.getFloors();
		for(int f=0;f<floors.size();f++){
			Vector rooms = ((Floor)floors.get(f)).getRooms();
			for(int r=0;r<rooms.size();r++){
				Vector walls = ((Room)rooms.get(r)).getWalls();
				for(int w=0;w<walls.size();w++){
					Wall wall = (Wall)walls.get(w);
					constructWall((Wall)walls.get(w));
					System.out.print(".");
				}
			}
		}
		//objRoot.compile();
		System.out.println("Finished rendering walls");
	    return objRoot;
	}

	public double dist(Position a, Position b){
		double x1 = convertLong(a.getPureLng());
		double z1 = convertLat(a.getPureLat());
		double y1 = 0.0d;
		double x2 = convertLong(b.getPureLng());
		double z2 = convertLat(b.getPureLat());
		double y2 = 0.3d; // chenge this to calculate height

		return Math.sqrt(((x2-x1)*(x2-x1))+((z2-z1)*(z2-z1)));
	}

	// Converts a GPS Latitude coordinate to a Java3d coordinate
	public double convertLat(double lat){
		double l = lat - minLat;
		return (scalingFactor * l) - 1.00000d;
	}

	// Converts a GPS Longitude coordinate to the Java3d coordinate
	public double convertLong(double lng){
		double l = lng - minLong;
		return (scalingFactor * l) - 1.00000d;
	}

	public void placeBox(Position a, Position b, double dpth, double top, double bottom){
		double x1 = convertLong(a.getPureLng());
		double z1 = convertLat(a.getPureLat());
		double y1 = bottom;
		double x2 = convertLong(b.getPureLng());
		double z2 = convertLat(b.getPureLat());
		double y2 = top; // chenge this to calculate height

		// Determine to dimensions of the wall
		float width = (float)dist(a,b);
		float height = (float)(y2-y1);
		float depth = (float)dpth; // change this to wall thickness

		Transform3D t = new Transform3D();

		// Calculate the Vector required to correctly position the center of the wall
		Vector3d wallPos =  new Vector3d((x2+x1), height + 2.0*bottom, (z2+z1));
		t.set(wallPos);
		// Rotate the wall so it is oriented correctly
		t.setRotation(new AxisAngle4d(0.0d,1.0d,0.0d,Math.atan(Math.abs(z1-z2)/Math.abs(x1-x2))));


		// Create TransformGroup, note: these capabilities allow us to move the wall during runtime
		TransformGroup wallTrans = new TransformGroup(t);
		wallTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		wallTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		wallTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
		objScale.addChild(wallTrans);

		// Create Geometry for wall
		//ColoringAttributes caWall = new ColoringAttributes();
		//caWall.setColor(lColor2);
		Appearance appWall = new Appearance();
		appWall.setTexture(tex);
		TextureAttributes texAttr = new TextureAttributes();
		texAttr.setTextureMode(TextureAttributes.MODULATE);
		appWall.setTextureAttributes(texAttr);
		//appWall.setColoringAttributes(caWall);
		wallTrans.addChild(new com.sun.j3d.utils.geometry.Box(width,height,depth,com.sun.j3d.utils.geometry.Box.GENERATE_TEXTURE_COORDS,appWall));

	}

	// Creates a vector of openings sorted from closest to farthest from Position1 on a Wall
	public Vector sortOpenings(Wall w){
		Vector o = new Vector();
		Vector open = w.getOpenings();
		Position ref = w.getPosition1();
		double[] dst = new double[open.size()];
		for(int i=0;i<open.size();i++){
			Opening op = (Opening)open.get(i);
			double d1 = dist(op.getPosition1(), ref);
			double d2 = dist(op.getPosition2(),ref);
			if( d1 < d2 )
				dst[i] = d1;
			else
				dst[i] = d2;
		}

		// Create an index
		int[] idx = new int[open.size()];
		for(int a=0;a<idx.length;a++)
			idx[a] = a;
		//Bubble sort openings from reference point
		//for(int a=0;a<idx.length-1;a++)
		//	for(int b=0;b<idx.length-1;a++){
		//			//System.out.print("<");
		//			if(dst[idx[b]] > dst[idx[b+1]]){
		//				int tmp = idx[b];
		//				idx[b] = idx[b+1];
		//				idx[b+1] = tmp;
		//			}
		//		//System.out.print(">");
		//	}

		//Populate Vector in order
		for(int i=0;i<open.size();i++)
			o.add(open.get(idx[i]));
		return o;
	}

	public void findScale(){
		Vector floors = building.getFloors();
		for(int f=0;f<floors.size();f++){
			Vector rooms = ((Floor)floors.get(f)).getRooms();
			for(int r=0;r<rooms.size();r++){
				Vector walls = ((Room)rooms.get(r)).getWalls();
				Vector furn = ((Room)rooms.get(r)).getFurnishings();
				System.out.println(furn.size());
				for(int w=0;w<walls.size();w++){
					double long1 = ((Wall)walls.get(w)).getPosition1().getPureLng();
					double lat1  = ((Wall)walls.get(w)).getPosition1().getPureLat();
					double long2 = ((Wall)walls.get(w)).getPosition2().getPureLng();
					double lat2  = ((Wall)walls.get(w)).getPosition2().getPureLat();
					int ht = ((Wall)walls.get(w)).getHeight();
					if(maxFloorHeight < ht)
						maxFloorHeight = ht;
					if(minLong == NOVAL)
						minLong = long1;
					if(maxLong == NOVAL)
						maxLong = long1;
					if(minLat == NOVAL)
						minLat = lat1;
					if(maxLat == NOVAL)
						maxLat = lat1;
					if(long1>maxLong)
						maxLong = long1;
					if(long1<minLong)
						minLong = long1;
					if(long2>maxLong)
						maxLong = long2;
					if(long2<minLong)
						minLong = long2;
					if(lat1>maxLat)
						maxLat = lat1;
					if(lat1<minLat)
						minLat = lat1;
					if(lat2>maxLat)
						maxLat = lat2;
					if(lat2<minLat)
						minLat = lat2;
				}
			}
		}
		double lngSize = maxLong - minLong;
		double latSize = maxLat - minLat;
		double fctrSize;
		if(lngSize>latSize)
			fctrSize = lngSize;
		else
			fctrSize = latSize;
		scalingFactor = (2.0d)/fctrSize;
	}

	public void constructWall(Wall w){

		boolean noOpenings = (w.getOpenings().size() == 0);
		Position last = w.getPosition1();
		if(noOpenings){
			placeBox(w.getPosition1(), w.getPosition2(),0.02d, ceilingHeight, floorHeight);
		}
		else{
			Vector openings = sortOpenings(w);
			for(int i=0;i<openings.size();i++){
				placeBox(last, ((Opening)openings.get(i)).getPosition1(), 0.02d, ceilingHeight,floorHeight);
				placeBox(((Opening)openings.get(i)).getPosition1(),((Opening)openings.get(i)).getPosition2(), 0.02d, ceilingHeight, (((double)((Opening)openings.get(i)).getTop())/((double)maxFloorHeight))*ceilingHeight);
				placeBox(((Opening)openings.get(i)).getPosition1(),((Opening)openings.get(i)).getPosition2(), 0.02d, (((double)((Opening)openings.get(i)).getBottom())/((double)maxFloorHeight))*ceilingHeight,0.0d);
				last = ((Opening)openings.get(i)).getPosition2();
			}
			placeBox(last, w.getPosition2(), 0.02d, 0.3d,0.0d);
		}
	}

	public BranchGroup getScene(){
		//BranchGroup bg = (BranchGroup)scene.cloneNode(true);
		//bg.detach();
		//try{
		//	scene.detach();
		//}catch(Exception e){System.out.println("ce:" +e);}
		return scene;
	}

	public void init() {
		//setLayout(new BorderLayout());
		GraphicsConfiguration config =
		    SimpleUniverse.getPreferredConfiguration();
		//Viewer viewer = new Viewer();
		//c = viewer.getCanvas3D();
		c = new Canvas3D(config);
		//ViewingPlatform vp = new ViewingPlatform();
		//viewer.setViewingPlatform(vp);
		//u = new SimpleUniverse(vp,viewer);

		//viewer.setVisible(true);
		//add("Center", c);

		//u = new SimpleUniverse(c);
		scene = createSceneGraph(c);


		// This will move the ViewPlatform back a bit so the
		// objects in the scene can be viewed.
		//u.getViewingPlatform().setNominalViewingTransform();

		//TransformGroup tg = u.getViewingPlatform().getViewPlatformTransform();
		//Transform3D t3drt = new Transform3D();
		////tg.getTransform(t3drt);
		//t3drt.lookAt(new Point3d(xPos,yPos,zPos),new Point3d(0.0,0.0,0.0),new Vector3d(0.0,1.0,0.0));
		//t3drt.invert();
		//tg.setTransform(t3drt);
		//changeView();
		//tg.addChild(u.getViewingPlatform());

		//u.addBranchGraph(scene);
		isLoaded = true;

		//c.setLeftManualEyeInImagePlate(new Point3d(0.0,0.0,10.5));
		//c.setRightManualEyeInImagePlate(new Point3d(0.0,0.0,10.5));
		//panel = new JPanel();
		//in = new JButton("/\\");
		//out= new JButton("\\/");
		//left = new JButton("<-");
		//right = new JButton("->");
		//god = new JButton("God");
		//panel.add(in);
		//panel.add(out);
		//panel.add(left);
		//panel.add(right);
		//panel.add(god);
		//add("South",panel);
		//in.addActionListener(new java.awt.event.ActionListener() {
		//	public void actionPerformed(java.awt.event.ActionEvent evt){
		//		inPressed(evt);
		//	}
		//});
		//out.addActionListener(new java.awt.event.ActionListener() {
		//	public void actionPerformed(java.awt.event.ActionEvent evt){
		//		outPressed(evt);
		//	}
		//});
		//left.addActionListener(new java.awt.event.ActionListener() {
		//	public void actionPerformed(java.awt.event.ActionEvent evt){
		//		leftPressed(evt);
		//	}
		//});
		//right.addActionListener(new java.awt.event.ActionListener() {
		//	public void actionPerformed(java.awt.event.ActionEvent evt){
		//		rightPressed(evt);
		//	}
		//});
		//god.addActionListener(new java.awt.event.ActionListener() {
		//			public void actionPerformed(java.awt.event.ActionEvent evt){
		//				godPressed(evt);
		//			}
		//});
	}

		private void inPressed(java.awt.event.ActionEvent evt){
			xPos += 0.06*Math.sin(Math.toRadians(heading));
			zPos += 0.06*Math.cos(Math.toRadians(heading));

			changeView();
		}
		private void outPressed(java.awt.event.ActionEvent evt){
			xPos += 0.06*Math.sin(Math.toRadians(180.0+heading));
			zPos += 0.06*Math.cos(Math.toRadians(180.0+heading));
			changeView();
		}
		private void leftPressed(java.awt.event.ActionEvent evt){
			heading += 5;
			if(heading>355)
				heading = 0;
			changeView();
		}
		private void rightPressed(java.awt.event.ActionEvent evt){
			heading -= 5;
			if(heading <0)
				heading = 355;
			changeView();
		}
		private void godPressed(java.awt.event.ActionEvent evt){
			TransformGroup tg = u.getViewingPlatform().getViewPlatformTransform();
			Transform3D t3drt = new Transform3D();
			//tg.getTransform(t3drt);
			t3drt.lookAt(new Point3d(1.0,7.0,1.0),new Point3d(0.0,0.0,0.0),new Vector3d(0.0,1.0,0.0));
			t3drt.invert();
			tg.setTransform(t3drt);
			//changeView();
		}

		public void changeView(){
			TransformGroup tg = u.getViewingPlatform().getViewPlatformTransform();
			Transform3D t3drt = new Transform3D();
			//tg.getTransform(t3drt);
			t3drt.lookAt(new Point3d(xPos + 0.75*Math.sin(Math.toRadians(heading)),yPos,zPos + 0.75*Math.cos(Math.toRadians(heading))),new Point3d(xPos,yPos,zPos),new Vector3d(0.0,1.0,0.0));
			t3drt.invert();
			tg.setTransform(t3drt);
		}

		public void changeView(Position p){
			xPos = 2.0*convertLong(p.getPureLng());
			zPos = 2.0*convertLat(p.getPureLat());
			System.out.println("Changing View to: ("+p.getPureLng()+","+p.getPureLat()+") => (" +xPos +"," +zPos+")");
			heading = p.getHeading() - 90;
			changeView();
		}

		//public void destroy() {
		//	u.cleanup();
    	//}
}